# CodéNav

Web App for cleaning, searching, editing, and navigating Python code.

## Install

pip install codenav

## Usage

1. "cd" to directory containing Python code
2. "codenav" command in terminal
3. App will open automatically in current browser

#### 1. Click on folder name to expand or contract the tree
![Step 1 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/86286af6-8be6-4eec-839c-9c4f5d989c8e/fa5c073a-1e63-4a3e-91b1-940d967d73b7.png?crop=focalpoint&fit=crop&fp-x=0.1522&fp-y=0.2098&fp-z=1.6719&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=6&mark-y=185&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz01OTgmaD0yMzImZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)

#### 2. OR click on caret-down to expand or contract the tree
![Step 2 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/3a4096be-6e7b-41ad-bf88-369b874850f5/5c062e28-e0ec-4818-b97b-417d780cec44.png?crop=focalpoint&fit=crop&fp-x=0.0663&fp-y=0.2429&fp-z=3.1283&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=223&mark-y=402&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz01MyZoPTUzJmZpdD1jcm9wJmNvcm5lci1yYWRpdXM9MTA%3D)

#### 3. Click on file to open contents in a tab
![Step 3 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/59036522-a799-4984-bd66-a3b255e9a03c/9164140a-fe78-490f-9a03-38fe98943926.png?crop=focalpoint&fit=crop&fp-x=0.1522&fp-y=0.4392&fp-z=1.1480&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=4&mark-y=123&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz00MTEmaD02MTEmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)

#### 4. Click on x to close tab
![Step 4 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/3e5ff715-236a-44fd-833d-0d78ad37c35c/5fcb3492-62c8-451e-85ff-0bc37841ee37.png?crop=focalpoint&fit=crop&fp-x=0.6368&fp-y=0.0284&fp-z=3.1070&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=571&mark-y=47&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz01OCZoPTU4JmZpdD1jcm9wJmNvcm5lci1yYWRpdXM9MTA%3D)

#### 5. Click on pencil button to edit the current file
![Step 5 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/124b9ad4-97b7-48e6-a809-17730d5e65f1/16da222f-0306-4790-b31c-8420f4ad5a6c.png?crop=focalpoint&fit=crop&fp-x=0.9514&fp-y=0.0273&fp-z=2.8911&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=974&mark-y=11&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0xMTQmaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)

#### 6. Click in tab window and start editing
![Step 6 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/9aae9b6d-dabb-41ee-9de2-cd84cfb63b86/d2cff769-0675-4292-9819-590a5bc8325a.png?crop=focalpoint&fit=crop&fp-x=0.6441&fp-y=0.3252&fp-z=1.1646&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=210&mark-y=46&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz05ODYmaD01NTgmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)

#### 7. Add new line ' print("extra printout here") '
![Step 8 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/4cfc3080-6bf1-411e-a4db-5c0310aa33ce/a962443f-71d4-4086-b237-9c3eff9e1da6.png?crop=focalpoint&fit=crop&fp-x=0.6441&fp-y=0.3252&fp-z=1.1646&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=210&mark-y=46&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz05ODYmaD01NTgmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 8. Click on Save button
![Step 9 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/11ea9047-8052-4a4d-ae37-ceec4f851c4d/c608f4f9-198f-46b0-abbd-61fb8ec0320d.png?crop=focalpoint&fit=crop&fp-x=0.3083&fp-y=0.0273&fp-z=2.8911&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=543&mark-y=11&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0xMTQmaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 9. Click run button to run the current file
![Step 10 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/4c9f0949-a562-40b1-8ab8-d6ee1b084447/ccf51456-01af-429d-bff8-cf3acee035a6.png?crop=focalpoint&fit=crop&fp-x=0.9212&fp-y=0.0273&fp-z=2.8911&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=870&mark-y=11&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0xMTQmaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 10. Stop a script while it is running with "Stop" button
![Step 11 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/5631e4cd-34ce-41f4-a4dd-98408885c627/8baf256f-93f7-48bc-8fd4-f47e5e6584fa.png?crop=focalpoint&fit=crop&fp-x=0.9212&fp-y=0.0273&fp-z=2.8911&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=870&mark-y=11&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0xMTQmaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 11. Click on 🔎 Search Code Content to search all code in the current directory
![Step 12 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/0cac49bc-1e5d-4077-a908-dc901fbb2c3d/4caabb3d-ed98-415b-89d0-c62b9766a962.png?crop=focalpoint&fit=crop&fp-x=0.1381&fp-y=0.0677&fp-z=1.7640&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=10&mark-y=76&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz01NjUmaD01MyZmaXQ9Y3JvcCZjb3JuZXItcmFkaXVzPTEw)


#### 12. Type one or more search terms
![Step 13 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/de18cfa5-837f-4b19-aaf1-d23f06c8e1eb/061f56a7-d807-44ce-85c3-02ff0649f744.png?crop=focalpoint&fit=crop&fp-x=0.0650&fp-y=0.0677&fp-z=2.9854&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=183&mark-y=129&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0xMDEmaD04OSZmaXQ9Y3JvcCZjb3JuZXItcmFkaXVzPTEw)


#### 13. Click on Open Snip to open the function or class with the most matches
![Step 14 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/b7ef12db-e3fb-4e0d-a90a-c0645368c195/38c5ef48-30e5-4778-bb8e-295615dda50e.png?crop=focalpoint&fit=crop&fp-x=0.3286&fp-y=0.1282&fp-z=2.7710&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=499&mark-y=247&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0yMDImaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 14. Click on Open File button to open the entire file containing the snip
![Step 15 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/a2a4e82b-ca28-4b96-9695-8a9cbff780ae/737a2ef1-8cb9-419d-a868-e6f323efb592.png?crop=focalpoint&fit=crop&fp-x=0.3286&fp-y=0.1901&fp-z=2.7710&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=499&mark-y=372&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0yMDImaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 15. Click on New Tab button to create empty tab
![Step 16 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/aa81522d-43ac-42d4-8eaf-4fa39944485d/8bba93c1-0590-4d34-977f-b25c878b025c.png?crop=focalpoint&fit=crop&fp-x=0.9813&fp-y=0.0273&fp-z=2.8911&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=1081&mark-y=11&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0xMDgmaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 16. Click "Up Folder" button to travel up one folder
![Step 17 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/7ddabf6c-f55a-4d32-8ba1-0d2360052cee/3dea09a8-b5f3-450e-b8b5-1dd3dd56d4f3.png?crop=focalpoint&fit=crop&fp-x=0.0195&fp-y=0.1096&fp-z=2.8911&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=11&mark-y=215&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0xMTQmaD0xMTQmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)


#### 17. Edit the path textbox to change the current directory
![Step 18 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/a17f3ec1-5f60-416a-afda-9f334796ca19/3f943cf5-ca13-42a7-83f6-ae388e83fd16.png?crop=focalpoint&fit=crop&fp-x=0.1600&fp-y=0.1096&fp-z=1.7737&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=60&mark-y=132&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz01NjEmaD03MCZmaXQ9Y3JvcCZjb3JuZXItcmFkaXVzPTEw)


#### 18. Click on "Clean File" button to run cleandoc on current file tab
![Step 19 screenshot](https://images.tango.us/workflows/2105e078-1d91-4fed-9527-b77787d623b8/steps/af602058-7f8a-45ce-bb21-c4d6ab5d420d/649bbcdb-4958-45d3-8a10-99f86bd2ad68.png?crop=focalpoint&fit=crop&fp-x=0.0523&fp-y=0.0284&fp-z=2.5104&w=1200&border=2%2CF4F2F7&border-radius=8%2C8%2C8%2C8&border-radius-inner=8%2C8%2C8%2C8&blend-align=bottom&blend-mode=normal&blend-x=0&blend-w=1200&blend64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL21hZGUtd2l0aC10YW5nby13YXRlcm1hcmstdjIucG5n&mark-x=9&mark-y=9&m64=aHR0cHM6Ly9pbWFnZXMudGFuZ28udXMvc3RhdGljL2JsYW5rLnBuZz9tYXNrPWNvcm5lcnMmYm9yZGVyPTYlMkNGRjc0NDImdz0yOTYmaD0xMDMmZml0PWNyb3AmY29ybmVyLXJhZGl1cz0xMA%3D%3D)

<br/>

## Read The Docs

Download "docs" folder or [check preview](https://htmlpreview.github.io/?https://github.com/jkrist2696/codenav/blob/main/docs/index.html).

## Contributing

Message me on Github.

## License

[GNU GPLv3](https://choosealicense.com/licenses/gpl-3.0/)

## Copyright:

(c) 2023, Jason Krist